package arabiannight.tistory.com;

public class TestInterface {

	public static void main(String[] args) {
		DotePrint dt = new DotePrint();
		InkPrint ip = new InkPrint();
		LaserPrint lp = new LaserPrint();
		dt.excutePrint(dt);
		ip.excutePrint(ip);
		lp.excutePrint(lp);
		System.out.println();
		dt.supplementInk(dt);
		ip.supplementInk(ip);
		lp.supplementInk(lp);
	}
}

interface Supplementable {} //잉크 충전 interface

class Print { //기본 프린트
	private int A4Size;  // A4용지 사이즈
	private int printSpeed;  // 인쇄 속도
	
	public Print(int size , int speed){
		this.A4Size = size;
		this.printSpeed = speed;
	}

	public int getA4Size(){	return this.A4Size;	}
	public int getPrintSpeed(){ return this.printSpeed; }

	public void excutePrint(Print p){ //인쇄 시작
		if(p instanceof Print){
			System.out.println(p.toString() + " 프린트로 인쇄 완료 되었습니다.");
			System.out.println("A4용지의 크기는 " + p.getA4Size() + " 입니다.");
			System.out.println("인쇄 속도는 " + p.getPrintSpeed() + " 입니다.");
		}
	}
	
	public void supplementInk(Supplementable s){ //잉크 충전
		if(s instanceof NeedInkPrint){
			NeedInkPrint np = (NeedInkPrint)s;
			if(np.getInkGage()!=np.getMaxInkGage()){
				np.setInkGage();
				System.out.println("잉크 충전이 완료 되었습니다.");
			}else{
				System.out.println("이미 충전이 완료 되어 있습니다. 확인 바랍니다.");
			}
		}else{
			System.out.println("잉크 충전 방식의 프린트가 아닙니다.");
		}
	}
}

class NeedInkPrint extends Print { //잉크 충전이 필요한 프린트
	private static final int MAX_INK_GAGE = 100;
	private int inkGage;
	public NeedInkPrint(int size, int speed, int ink) {
		super(size, speed);
		this.inkGage = ink;
	}
	
	public void setInkGage(){ this.inkGage = MAX_INK_GAGE; }
	public int getInkGage(){ return this.inkGage; }
	public static int getMaxInkGage(){ return MAX_INK_GAGE; }
}

class DotePrint extends NeedInkPrint implements Supplementable{ //도트 프린트
	public DotePrint() {
		super(80, 30, 100);
	}
	public String toString(){
		return "도트";
	}
}

class InkPrint extends NeedInkPrint implements Supplementable{ //잉크젯 프린트
	public InkPrint() {
		super(80, 60, 63);
	}
	public String toString(){
		return "잉크젯";
	}
}

class LaserPrint extends Print implements Supplementable{ //레이져 프린트
	public LaserPrint() {
		super(80, 100);
	}
	public String toString(){
		return "레이져";
	}
}